| XMP Toolkit SDK 6.0.0

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
AdobeXMPCore::IArrayNode_v1 Class Referenceabstract

Version1 of the interface that represents an Array Node of XMP DOM. More...

`#include <IArrayNode.h>`

Inheritance diagram for AdobeXMPCore::IArrayNode_v1:

## Public Types
enum | eArrayForm { kAFNone = 0, kAFUnordered = 1 << 0, kAFOrdered = 1 << 1, kAFAlternative = 1 << 2, kAFAll = kAllBits }
| Indicates different kinds of array forms possible in XMP i.e, unordered, ordered and alternative. More...
Public Types inherited from AdobeXMPCore::INode_v1
enum | eNodeType { kNTNone = 0, kNTSimple = 1, kNTArray = 1 << 1, kNTStructure = 1 << 2, kNTAll = kAllBits }
| Indicates various types of node available in XMP Data Model like simple, array and structure. More...

## Public Member Functions
virtual eArrayForm APICALL | GetArrayForm () const =0
| Get the type of array. More...
virtual eNodeType APICALL | GetChildNodeType () const =0
| Get the type of child nodes. More...
virtual void APICALL | InsertNodeAtIndex (const spINode &node, sizet index)=0
| Inserts a given node at the specified index. More...
virtual spINode APICALL | ReplaceNodeAtIndex (const spINode &node, sizet index)=0
| Replaces an existing node with the given node at the specified index. More...
virtual spINode APICALL | RemoveNodeAtIndex (sizet index)=0
| Remove the node at the specified index. More...
virtual spINode APICALL | GetNodeAtIndex (sizet index)=0
| Get the node at the specified index. More...
XMP_PRIVATE spcINode | GetNodeAtIndex (sizet index) const
XMP_PRIVATE spcISimpleNode | GetSimpleNodeAtIndex (sizet index) const
| Get the node at the specified index as simple node, if possible. More...
XMP_PRIVATE spISimpleNode | GetSimpleNodeAtIndex (sizet index)
XMP_PRIVATE spcIStructureNode | GetStructureNodeAtIndex (sizet index) const
| Get the node at the specified index as structure node, if possible. More...
XMP_PRIVATE spIStructureNode | GetStructureNodeAtIndex (sizet index)
XMP_PRIVATE spcIArrayNode | GetArrayNodeAtIndex (sizet index) const
| Get the node at the specified index as an array node, if possible. More...
XMP_PRIVATE spIArrayNode | GetArrayNodeAtIndex (sizet index)
Public Member Functions inherited from AdobeXMPCore::ICompositeNode_v1
virtual eNodeType APICALL | GetNodeTypeAtPath (const spcIPath &path) const =0
| Get the node type specified by the path relative to the composite node. More...
virtual void APICALL | AppendNode (const spINode &node)=0
| Appends a given node as the child of the node. More...
virtual void APICALL | InsertNodeAtPath (const spINode &node, const spcIPath &path)=0
| Inserts a given node at the path relative to the composite node. More...
virtual spINode APICALL | ReplaceNodeAtPath (const spINode &node, const spcIPath &path)=0
| Replaces an existing node with the given node at the path relative to the composite node.. More...
virtual spINode APICALL | RemoveNodeAtPath (const spcIPath &path)=0
| Removes the node specified by the path relative to the composite node. More...
XMP_PRIVATE spcINode | GetNodeAtPath (const spcIPath &path) const
| Get the node specified by the path relative to the composite node. More...
virtual spINode APICALL | GetNodeAtPath (const spcIPath &path)=0
virtual spINodeIterator APICALL | Iterator ()=0
| Get an iterator object to iterate over all the child nodes of the composite node. More...
XMP_PRIVATE spcINodeIterator | Iterator () const
virtual sizet APICALL | ChildCount () const __NOTHROW__=0
| Get the count of child nodes of the composite node. More...
XMP_PRIVATE spcISimpleNode | GetSimpleNodeAtPath (const spcIPath &path) const
| Get a simple node specified by the path relative to the node. More...
XMP_PRIVATE spISimpleNode | GetSimpleNodeAtPath (const spcIPath &path)
XMP_PRIVATE spcIStructureNode | GetStructureNodeAtPath (const spcIPath &path) const
| Get a structure node specified by the path relative to the node. More...
XMP_PRIVATE spIStructureNode | GetStructureNodeAtPath (const spcIPath &path)
XMP_PRIVATE spcIArrayNode | GetArrayNodeAtPath (const spcIPath &path) const
| Get an array node specified by the path relative to the node. More...
XMP_PRIVATE spIArrayNode | GetArrayNodeAtPath (const spcIPath &path)
Public Member Functions inherited from AdobeXMPCore::INode_v1
virtual eNodeType APICALL | GetNodeType () const =0
| Gets the node type of the node. More...
virtual eNodeType APICALL | GetParentNodeType () const =0
| Gets the node type of the node's parent. More...
virtual void APICALL | SetName (const char *name, sizet nameLength)=0
| Changes the local name of the node. More...
virtual spcIUTF8String APICALL | GetName () const =0
| Gets the local name of the node. More...
virtual void APICALL | SetNameSpace (const char *nameSpace, sizet nameSpaceLength)=0
| Changes the name space of the node. More...
virtual spcIUTF8String APICALL | GetNameSpace () const =0
| Gets the name space of the node. More...
virtual spIPath APICALL | GetPath () const =0
| Gets the path of the node from the root of the metadata. More...
virtual sizet APICALL | QualifiersCount () const __NOTHROW__=0
| Gets the count of the qualifiers attached with the node. More...
virtual eNodeType APICALL | GetQualifierNodeType (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const =0
| Gets the type of the node's qualifier having specified namespace and name. More...
virtual void APICALL | InsertQualifier (const spINode &node)=0
| Inserts a given qualifier node. More...
virtual spINode APICALL | ReplaceQualifier (const spINode &node)=0
| Replaces a given qualifier node. More...
virtual spINode APICALL | RemoveQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)=0
| Removes the qualifier node with the specified nameSpace and name. More...
virtual bool APICALL | IsArrayItem () const =0
| Indicates whether the node is a direct child of an array node. More...
virtual bool APICALL | IsQualifierNode () const =0
| Indicates whether the node is a qualifier node. More...
virtual sizet APICALL | GetIndex () const =0
| Returns the index of the node in case it is an array item. More...
virtual bool APICALL | HasQualifiers () const =0
| Indicates whether the node has any qualifiers associated with it. More...
virtual bool APICALL | HasContent () const =0
| Returns whether the node has any content or not. return A bool value indicating the presence of contents in the node apart from qualifiers. More...
virtual bool APICALL | IsEmpty () const =0
| Returns whether the node is empty. return A bool value indicating whether the contents and qualifiers of a node are empty. More...
virtual bool APICALL | HasChanged () const =0
| Returns the status about any change done to the node or its children or qualifiers. returns a bool value indicating whether some changes have been performed on the node or its children or qualifiers. for a simple node, true will be returned in scenarios like when the node's value or qualifiers are modified. for an array node or a structure node, true will be returned in scenarios like when the node's children or the node's qualifiers are modified. More...
virtual void APICALL | AcknowledgeChanges () const __NOTHROW__=0
| Acknowledges that changes for the node and its children and qualifiers have been taken care of. for a simple node, changes that will be acknowledged in scenarios like when the node's value or node's qualifiers were modified. for an array node or a structure node, changes will be acknowledged in scenarios like when the node's children were or the node's qualifiers were modified. More...
virtual void APICALL | Clear (bool contents=true, bool qualifiers=true)=0
| Clear the contents of the node. More...
virtual spINode APICALL | Clone (bool ignoreEmptyNodes=false, bool ignoreNodesWithOnlyQualifiers=false) const =0
| Virtual copy constructor. More...
XMP_PRIVATE spcINode | GetParent () const
| Gets the parent node of the node. More...
virtual spINode APICALL | GetParent ()=0
XMP_PRIVATE spcINodeIterator | QualifiersIterator () const
virtual spINodeIterator APICALL | QualifiersIterator ()=0
XMP_PRIVATE spcINode | GetQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Gets the qualifier of the node having specified namespace and name. More...
virtual spINode APICALL | GetQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)=0
XMP_PRIVATE spcISimpleNode | GetSimpleQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Get the node's qualifier having specified name space and name as simple node. More...
XMP_PRIVATE spISimpleNode | GetSimpleQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
XMP_PRIVATE spcIStructureNode | GetStructureQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Get the node's qualifier having specified name space and name as structure node. More...
XMP_PRIVATE spIStructureNode | GetStructureQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
XMP_PRIVATE spcIArrayNode | GetArrayQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength) const
| Get the node's qualifier having specified name space and name as an array node. More...
XMP_PRIVATE spIArrayNode | GetArrayQualifier (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
XMP_PRIVATE spcISimpleNode | ConvertToSimpleNode () const
| Converts Node to a simple node, if possible. More...
virtual spISimpleNode APICALL | ConvertToSimpleNode ()=0
XMP_PRIVATE spcIStructureNode | ConvertToStructureNode () const
| Converts Node to a structure node type, if possible. More...
virtual spIStructureNode APICALL | ConvertToStructureNode ()=0
XMP_PRIVATE spcIArrayNode | ConvertToArrayNode () const
| Converts Node to an array node type, if possible. More...
virtual spIArrayNode APICALL | ConvertToArrayNode ()=0
XMP_PRIVATE spcIMetadata | ConvertToMetadata () const
| Converts Node to a metadata node type, if possible. More...
virtual spIMetadata APICALL | ConvertToMetadata ()=0
Public Member Functions inherited from AdobeXMPCommon::ISharedObject
virtual void APICALL | Acquire () const __NOTHROW__=0
| Called by the clients of the object to indicate that he has acquired the shared ownership of the object. More...
virtual void APICALL | Release () const __NOTHROW__=0
| Called by the clients of the object to indicate he has released his shared ownership of the object. If this being the last client than this function should call Destroy to delete and release the memory. More...
Public Member Functions inherited from AdobeXMPCommon::IVersionable
template<typename requestedInterface >
XMP_PRIVATE requestedInterface * | GetInterfacePointer ()
| Get the raw pointer to an interface object implementing the requested version. More...
template<typename requestedInterface >
const XMP_PRIVATE requestedInterface * | GetInterfacePointer () const
| Get the raw pointer to a const interface object implementing the requested version. More...
Public Member Functions inherited from AdobeXMPCommon::IThreadSafe
virtual void APICALL | EnableThreadSafety () const __NOTHROW__=0
| Enables the thread safety on an object. More...
virtual void APICALL | DisableThreadSafety () const __NOTHROW__=0
| Disables the thread safety on an object. More...
virtual bool APICALL | IsThreadSafe () const =0
| Informs whether object can be used across multiple threads or not. More...

## Static Public Member Functions
static XMP_PRIVATE spIArrayNode | CreateUnorderedArrayNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
| Creates an unordered array node which is not part of any metadata document. More...
static XMP_PRIVATE spIArrayNode | CreateOrderedArrayNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
| Creates an ordered array node which is not part of any metadata document. More...
static XMP_PRIVATE spIArrayNode | CreateAlternativeArrayNode (const char *nameSpace, sizet nameSpaceLength, const char *name, sizet nameLength)
| Creates an alternative array node which is not part of any metadata document. More...

## Protected Member Functions
virtual | ~IArrayNode_v1 () __NOTHROW__
Protected Member Functions inherited from AdobeXMPCore::ICompositeNode_v1
virtual | ~ICompositeNode_v1 () __NOTHROW__
Protected Member Functions inherited from AdobeXMPCore::INode_v1
virtual | ~INode_v1 () __NOTHROW__
Protected Member Functions inherited from AdobeXMPCommon::ISharedObject
virtual | ~ISharedObject () __NOTHROW__=0
| REQ_FRIEND_CLASS_DECLARATION ()
Protected Member Functions inherited from AdobeXMPCommon::IVersionable
virtual | ~IVersionable ()
| REQ_FRIEND_CLASS_DECLARATION ()
Protected Member Functions inherited from AdobeXMPCommon::IThreadSafe
| REQ_FRIEND_CLASS_DECLARATION ()

## Detailed Description

Version1 of the interface that represents an Array Node of XMP DOM.

Provides all the functions to get and set various properties of the array node.

Attention
  Support multi threading through locks but can be enabled/disabled by the client. By default every object created does not support multi-threading.

Note
  The index of the array is 1-based.

Definition at line 27 of file IArrayNode.h.

## Member Enumeration Documentation

## ◆ eArrayForm

enum AdobeXMPCore::IArrayNode_v1::eArrayForm

Indicates different kinds of array forms possible in XMP i.e, unordered, ordered and alternative.

Enumerator
kAFNone | unknown array form, should be used as invalid value.
kAFUnordered | Array contains entries which are unordered.
kAFOrdered | Array contains entries which are ordered.
kAFAlternative | Array contains entries which are ordered plus default value should be the top one.
kAFAll | Maximum value this enum can hold, should be treated as invalid value.

Definition at line 35 of file IArrayNode.h.

35 {
37 kAFNone = 0,
38
40 kAFUnordered = 1 << 0,
41
43 kAFOrdered = 1 << 1,
44
46 kAFAlternative = 1 << 2,
47
49 kAFAll = kAllBits
50 } eArrayForm;

## Constructor & Destructor Documentation

## ◆ ~IArrayNode_v1()

virtual AdobeXMPCore::IArrayNode_v1::~IArrayNode_v1 | ( |  | ) |
| inline protected virtual

Destructor

Definition at line 286 of file IArrayNode.h.

286 {}

## Member Function Documentation

## ◆ CreateAlternativeArrayNode()

static XMP_PRIVATE spIArrayNode AdobeXMPCore::IArrayNode_v1::CreateAlternativeArrayNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| static

Creates an alternative array node which is not part of any metadata document.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the array node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to #AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the array node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to #AdobeXMPCommon::npos.

Returns
  A shared pointer to a #IArrayNode object.

Attention
  Error is thrown in the following cases:
  1. nameSpace is NULL or its contents are empty.
  2. name is NULL or its contents are empty.

## ◆ CreateOrderedArrayNode()

static XMP_PRIVATE spIArrayNode AdobeXMPCore::IArrayNode_v1::CreateOrderedArrayNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| static

Creates an ordered array node which is not part of any metadata document.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the array node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated set it to #AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the array node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to #AdobeXMPCommon::npos.

Returns
  A shared pointer to a #IArrayNode object.

Attention
  Error is thrown in the following cases:
  1. nameSpace is NULL or its contents are empty.
  2. name is NULL or its contents are empty.

## ◆ CreateUnorderedArrayNode()

static XMP_PRIVATE spIArrayNode AdobeXMPCore::IArrayNode_v1::CreateUnorderedArrayNode | ( | const char * | nameSpace,
|  | sizet | nameSpaceLength,
|  | const char * | name,
|  | sizet | nameLength
| ) |  |
| static

Creates an unordered array node which is not part of any metadata document.

Parameters

  [in] | nameSpace | Pointer to a constant char buffer containing name space URI of the array node.
  [in] | nameSpaceLength | Number of characters in nameSpace. In case nameSpace is null terminated, set it to #AdobeXMPCommon::npos.
  [in] | name | Pointer to a constant char buffer containing local name of the array node.
  [in] | nameLength | Number of characters in name. In case name is null terminated set it to #AdobeXMPCommon::npos.

Returns
  A shared pointer to a #IArrayNode object.

Attention
  Error is thrown in the following cases:
  1. nameSpace is NULL or its contents are empty.
  2. name is NULL or its contents are empty.

## ◆ GetArrayForm()

virtual eArrayForm APICALL AdobeXMPCore::IArrayNode_v1::GetArrayForm | ( |  | ) | const
| pure virtual

Get the type of array.

Returns
  a value of type eArrayForm indicating the type of array.

## ◆ GetArrayNodeAtIndex() [1/2]

XMP_PRIVATE spIArrayNode AdobeXMPCore::IArrayNode_v1::GetArrayNodeAtIndex | ( | sizet | index | ) |
| inline

Definition at line 141 of file IArrayNode.h.

141 {
142 auto node = GetNodeAtIndex( index );
143 if ( node ) return node->ConvertToArrayNode();
144 return spIArrayNode();
145 }

## ◆ GetArrayNodeAtIndex() [2/2]

XMP_PRIVATE spcIArrayNode AdobeXMPCore::IArrayNode_v1::GetArrayNodeAtIndex | ( | sizet | index | ) | const
| inline

Get the node at the specified index as an array node, if possible.

Parameters

  [in] | index | an object of type #sizet indicating the index of the node client is interested in.

Returns
  a shared pointer to const or non const #IArrayNode object containing node.

Note
  In case no node exists at the given index an invalid shared pointer is returned.
  The index of an array is 1-based.

Attention
  Error is thrown in case
  - a child exists at the given index but is not an array node.

Definition at line 135 of file IArrayNode.h.

135 {
136 auto node = GetNodeAtIndex( index );
137 if ( node ) return node->ConvertToArrayNode();
138 return spcIArrayNode();
139 }

## ◆ GetChildNodeType()

virtual eNodeType APICALL AdobeXMPCore::IArrayNode_v1::GetChildNodeType | ( |  | ) | const
| pure virtual

Get the type of child nodes.

Returns
  a value of type eNodeType indicating the type of child nodes array can hold.

Note
  An empty array will return #INode_v1::kNTAll indicating that right now it can hold any type of node.

## ◆ GetNodeAtIndex() [1/2]

XMP_PRIVATE spcINode AdobeXMPCore::IArrayNode_v1::GetNodeAtIndex | ( | sizet | index | ) | const
| inline

Definition at line 74 of file IArrayNode.h.

74 {
75 return const_cast< IArrayNode_v1 * >( this )->GetNodeAtIndex( index );
76 }

## ◆ GetNodeAtIndex() [2/2]

virtual spINode APICALL AdobeXMPCore::IArrayNode_v1::GetNodeAtIndex | ( | sizet | index | ) |
| pure virtual

Get the node at the specified index.

Parameters

  [in] | index | an object of type #sizet indicating the index of the node client who is interested in.

Returns
  A shared pointer to const or non const #INode object containing node.

Note
  In case no node exists at the given index an invalid shared pointer is returned.
  The index of an array is 1-based.

## ◆ GetSimpleNodeAtIndex() [1/2]

XMP_PRIVATE spISimpleNode AdobeXMPCore::IArrayNode_v1::GetSimpleNodeAtIndex | ( | sizet | index | ) |
| inline

Definition at line 95 of file IArrayNode.h.

95 {
96 auto node = GetNodeAtIndex( index );
97 if ( node ) return node->ConvertToSimpleNode();
98 return spISimpleNode();
99 }

## ◆ GetSimpleNodeAtIndex() [2/2]

XMP_PRIVATE spcISimpleNode AdobeXMPCore::IArrayNode_v1::GetSimpleNodeAtIndex | ( | sizet | index | ) | const
| inline

Get the node at the specified index as simple node, if possible.

Parameters

  [in] | index | An object of type #sizet indicating the index of the node client is interested in.

Returns
  A shared pointer to const or non const #ISimpleNode object containing node.

Note
  In case no node exists at the given index an invalid shared pointer is returned.
  The index of an array is 1-based.

Attention
  Error is thrown in case
  - a child exists at the given index but is not a simple node.

Definition at line 89 of file IArrayNode.h.

89 {
90 auto node = GetNodeAtIndex( index );
91 if ( node ) return node->ConvertToSimpleNode();
92 return spcISimpleNode();
93 }

## ◆ GetStructureNodeAtIndex() [1/2]

XMP_PRIVATE spIStructureNode AdobeXMPCore::IArrayNode_v1::GetStructureNodeAtIndex | ( | sizet | index | ) |
| inline

Definition at line 118 of file IArrayNode.h.

118 {
119 auto node = GetNodeAtIndex( index );
120 if ( node ) return node->ConvertToStructureNode();
121 return spIStructureNode();
122 }

## ◆ GetStructureNodeAtIndex() [2/2]

XMP_PRIVATE spcIStructureNode AdobeXMPCore::IArrayNode_v1::GetStructureNodeAtIndex | ( | sizet | index | ) | const
| inline

Get the node at the specified index as structure node, if possible.

Parameters

  [in] | index | An object of type #sizet indicating the index of the node client is interested in.

Returns
  A shared pointer to const or non const #IStructureNode object containing node.

Note
  In case no node exists at the given index an invalid shared pointer is returned.
  The index of an array is 1-based.

Attention
  Error is thrown in case
  - a child exists at the given index but is not a structure node.

Definition at line 112 of file IArrayNode.h.

112 {
113 auto node = GetNodeAtIndex( index );
114 if ( node ) return node->ConvertToStructureNode();
115 return spcIStructureNode();
116 }

## ◆ InsertNodeAtIndex()

virtual void APICALL AdobeXMPCore::IArrayNode_v1::InsertNodeAtIndex | ( | const spINode & | node,
|  | sizet | index
| ) |  |
| pure virtual

Inserts a given node at the specified index.

Parameters

  [in] | node | Shared pointer to an object of #INode containing the node to be inserted at the specified index.
  [in] | index | An object of type sizet indicating the index where the node should be inserted.

Note
  The index of an array is 1-based.

Attention
  Error is thrown in following cases:
  1. given node is invalid.
  2. type of given node is not same as other child items of the array node.
  3. given node is already a child of some other node.
  4. given index is less than 1 or greater than current child count + 1.

## ◆ RemoveNodeAtIndex()

virtual spINode APICALL AdobeXMPCore::IArrayNode_v1::RemoveNodeAtIndex | ( | sizet | index | ) |
| pure virtual

Remove the node at the specified index.

Parameters

  [in] | index | An object of type #sizet indicating the index from where the node should be removed.

Note
  The index of an array is 1-based.

Returns
  A shared pointer to #INode object containing node which is removed from the tree.

Note
  In case no node exists at the given index an invalid shared pointer is returned.

## ◆ ReplaceNodeAtIndex()

virtual spINode APICALL AdobeXMPCore::IArrayNode_v1::ReplaceNodeAtIndex | ( | const spINode & | node,
|  | sizet | index
| ) |  |
| pure virtual

Replaces an existing node with the given node at the specified index.

Parameters

  [in] | node | Shared pointer to an object of #INode containing the node to be inserted at the specified index.
  [in] | index | An object of type #sizet indicating the index from where the node should be replaced.

Returns
  A shared pointer to the node replaced with the new node.

Note
  The index of an array is 1-based.

Attention
  Error is thrown in following cases:
  1. Given node is invalid.
  2. Type of given node is not same as other child items of the array node.
  3. Given node is already a child of some other node.
  4. Given index is less than 1 or greater than current child count.
  5. No node exists at the requested index.

The documentation for this class was generated from the following file:

- public/include/XMPCore/Interfaces/IArrayNode.h

AdobeXMPCore::spIStructureNode
shared_ptr< IStructureNode > spIStructureNode
Definition: XMPCoreFwdDeclarations.h:103
AdobeXMPCore::IArrayNode_v1::eArrayForm
eArrayForm
Indicates different kinds of array forms possible in XMP i.e, unordered, ordered and alternative.
Definition: IArrayNode.h:35
AdobeXMPCore::spISimpleNode
shared_ptr< ISimpleNode > spISimpleNode
Definition: XMPCoreFwdDeclarations.h:79
AdobeXMPCore::IArrayNode_v1::kAFOrdered
@ kAFOrdered
Array contains entries which are ordered.
Definition: IArrayNode.h:43
AdobeXMPCore::IArrayNode_v1::kAFAlternative
@ kAFAlternative
Array contains entries which are ordered plus default value should be the top one.
Definition: IArrayNode.h:46
AdobeXMPCore::spIArrayNode
shared_ptr< IArrayNode > spIArrayNode
Definition: XMPCoreFwdDeclarations.h:115
AdobeXMPCore::spcISimpleNode
shared_ptr< const ISimpleNode > spcISimpleNode
Definition: XMPCoreFwdDeclarations.h:80
AdobeXMPCore::spcIArrayNode
shared_ptr< const IArrayNode > spcIArrayNode
Definition: XMPCoreFwdDeclarations.h:116
AdobeXMPCore::IArrayNode_v1::kAFNone
@ kAFNone
unknown array form, should be used as invalid value.
Definition: IArrayNode.h:37
AdobeXMPCore::IArrayNode_v1::GetNodeAtIndex
virtual spINode APICALL GetNodeAtIndex(sizet index)=0
Get the node at the specified index.
AdobeXMPCore::IArrayNode_v1::kAFAll
@ kAFAll
Maximum value this enum can hold, should be treated as invalid value.
Definition: IArrayNode.h:49
AdobeXMPCore::spcIStructureNode
shared_ptr< const IStructureNode > spcIStructureNode
Definition: XMPCoreFwdDeclarations.h:104
AdobeXMPCore::IArrayNode_v1::kAFUnordered
@ kAFUnordered
Array contains entries which are unordered.
Definition: IArrayNode.h:40
AdobeXMPCommon::kAllBits
static const uint32 kAllBits(0xFFFFFFFF)